<section class="filter-container">
  <mat-form-field>
    <mat-label>Filter</mat-label>
    <input matInput (keyup)="applyFilter($event)" placeholder="Filter by Entry/Desc">
    <i class="fa fa-filter" aria-hidden="true"></i>
  </mat-form-field>
</section>
<div class="mat-elevation-z8">
    <table mat-table matSort [dataSource]="dataSource">
  
      <!-- Position Column -->
    <ng-container matColumnDef="S.No">
        <th mat-header-cell *matHeaderCellDef> S.No </th>
        <td class="link" mat-cell *matCellDef="let element; let i = index;"> {{i + 1}}
        </td>
      </ng-container>
  
      <ng-container matColumnDef="user">
        <th mat-header-cell *matHeaderCellDef> User </th>
        <td mat-cell *matCellDef="let element"> {{element.user}} </td>
      </ng-container>
      <ng-container matColumnDef="date">
        <th mat-header-cell *matHeaderCellDef> Date </th>
        <td mat-cell *matCellDef="let element"> {{element.date | date: 'dd-MMM-yyyy'}} </td>
      </ng-container>
      <ng-container matColumnDef="company">
        <th mat-header-cell *matHeaderCellDef> Company </th>
        <td mat-cell *matCellDef="let element"> {{element.company}} </td>
      </ng-container>
      <ng-container matColumnDef="ledgerAccount.accountNumber">
        <th mat-header-cell *matHeaderCellDef> Account Number </th>
        <td mat-cell *matCellDef="let element"> {{element.ledgerAccount?.accountNumber}} </td>
      </ng-container>
      <ng-container matColumnDef="ledgerAccount.accountType">
        <th mat-header-cell *matHeaderCellDef> Account Type </th>
        <td mat-cell *matCellDef="let element"> {{element.ledgerAccount?.accountType}} </td>
      </ng-container>
      <ng-container matColumnDef="currency">
        <th mat-header-cell *matHeaderCellDef> Currency </th>
        <td mat-cell *matCellDef="let element"> {{element.currency}} </td>
      </ng-container>
  
      <!-- created Column -->
      <ng-container matColumnDef="order.referenceOrderData.code2">
        <th mat-header-cell *matHeaderCellDef> Material Entry </th>
        <td mat-cell *matCellDef="let element"> {{element.order?.referenceOrderData?.code2}} </td>
      </ng-container>
      <ng-container matColumnDef="order.referenceOrderData.referenceOrder2">
        <th mat-header-cell *matHeaderCellDef> Reference Order </th>
        <td mat-cell *matCellDef="let element"> {{element.order?.referenceOrderData?.referenceOrder2}} </td>
      </ng-container>
  
      <!-- Amount Column -->
      <ng-container matColumnDef="order.referenceOrder2">
        <th mat-header-cell *matHeaderCellDef> Order No </th>
        <td mat-cell *matCellDef="let element"> {{element.order?.referenceOrder2}} </td>
      </ng-container>
      <ng-container matColumnDef="order.code2">
        <th mat-header-cell *matHeaderCellDef> Material Entry </th>
        <td mat-cell *matCellDef="let element"> {{element.order?.code2}} </td>
      </ng-container>
      <!-- Status Column -->
      <ng-container matColumnDef="company.bpCode">
        <th mat-header-cell *matHeaderCellDef>{{page == 'AP' ? 'Supplier Code' : 'Customer Code'}}</th>
        <td mat-cell *matCellDef="let element">{{element.company?.bpCode}} </td>
      </ng-container>
      <ng-container matColumnDef="order.company.bpCode">
        <th mat-header-cell *matHeaderCellDef>{{page == 'AP' ? 'Supplier Code' : 'Customer Code'}}</th>
        <td mat-cell *matCellDef="let element">{{element.order?.company?.bpCode}} </td>
      </ng-container>
      <!-- Status Column -->
      <ng-container matColumnDef="company.name">
        <th mat-header-cell *matHeaderCellDef> Company Name </th>
        <td mat-cell *matCellDef="let element">{{element.company?.name}} </td>
      </ng-container>
      <!-- Status Column -->
      <ng-container matColumnDef="order.currency">
        <th mat-header-cell *matHeaderCellDef> Currency </th>
        <td mat-cell *matCellDef="let element">{{element.order?.currency}} </td>
      </ng-container>
      
      <!-- Status Column -->
      <ng-container matColumnDef="order.invoiceNumber">
        <th mat-header-cell *matHeaderCellDef> Invoice Number </th>
        <td mat-cell *matCellDef="let element">{{element.order?.invoiceNumber}} </td>
      </ng-container>
      <ng-container matColumnDef="invoiceNumber2">
        <th mat-header-cell *matHeaderCellDef> Invoice Number </th>
        <td mat-cell *matCellDef="let element">{{element.invoiceNumber2}} </td>
      </ng-container>
      <!-- Status Column -->
      <ng-container matColumnDef="order.invoiceDate">
        <th mat-header-cell *matHeaderCellDef> Invoice Date  </th>
        <td mat-cell *matCellDef="let element">{{element.order?.invoiceDate}} </td>
      </ng-container>
      <ng-container matColumnDef="order.referenceOrderData.currency2">
        <th mat-header-cell *matHeaderCellDef> Currency  </th>
        <td mat-cell *matCellDef="let element">{{element.order?.referenceOrderData?.currency2}} </td>
      </ng-container>
      <ng-container matColumnDef="order.invoiceDate2">
        <th mat-header-cell *matHeaderCellDef> Invoice Date  </th>
        <td mat-cell *matCellDef="let element">{{element.order?.invoiceDate2}} </td>
      </ng-container>
      <!-- Status Column -->
      <ng-container matColumnDef="order.currency2">
        <th mat-header-cell *matHeaderCellDef> Currency </th>
        <td mat-cell *matCellDef="let element">{{element.order?.currency2}} </td>
      </ng-container>
      <!-- Status Column -->
      <ng-container matColumnDef="amount">
        <th mat-header-cell *matHeaderCellDef>Amount </th>
        <td mat-cell *matCellDef="let element">{{element.amount | number : '1.0-2'}} </td>
      </ng-container>
      <!-- Status Column -->
      <ng-container matColumnDef="totalAmountInSAR">
        <th mat-header-cell *matHeaderCellDef>Amount In SAR </th>
        <td mat-cell *matCellDef="let element">{{element.totalAmountInSAR | number : '1.0-2'}} </td>
      </ng-container>
      <!-- Status Column -->
      <ng-container matColumnDef="accountNumber">
        <th mat-header-cell *matHeaderCellDef> Account Number </th>
        <td mat-cell *matCellDef="let element">{{element.accountNumber}} </td>
      </ng-container>
      <!-- Status Column -->
      <ng-container matColumnDef="description">
        <th mat-header-cell *matHeaderCellDef> Description  </th>
        <td mat-cell *matCellDef="let element">{{element.description}} </td>
      </ng-container>
      <ng-container matColumnDef="type">
        <th mat-header-cell *matHeaderCellDef> Type  </th>
        <td mat-cell *matCellDef="let element">{{element.type}} </td>
      </ng-container>
      <!-- name Column -->
      <ng-container matColumnDef="creditOrDebit">
        <th mat-header-cell *matHeaderCellDef> Type </th>
        <td mat-cell *matCellDef="let element">{{element.creditOrDebit}} </td>
      </ng-container>
      <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
      <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
    </table>
    <mat-paginator [pageSizeOptions]="[5, 10, 20]" showFirstLastButtons></mat-paginator>
  </div>